/* Automatically generated by refactor.pl.
 *
 *
 * CMDNAME: title
 * CMDLEVEL: QCMD_TITLES | QCMD_AUTHED
 * CMDARGS: 1
 * CMDDESC: Lists available titles, or sets your title.
 * CMDFUNC: csh_dotitle
 * CMDPROTO: int csh_dotitle(void *source, int cargc, char **cargv);
 * CMDHELP: Usage: @UCOMMAND@ [<id>]
 * CMDHELP: Lists available titles, or selects a title.
 * CMDHELP: id   - Title ID to select.  If omitted, gives a list of 
 * CMDHELP:        available titles and IDs.
 */

#include "../chanserv.h"
#include "../../nick/nick.h"
#include "../../lib/flags.h"
#include "../../lib/irc_string.h"
#include "../../channel/channel.h"
#include "../../parser/parser.h"
#include "../../irc/irc.h"
#include "../../localuser/localuserchannel.h"
#include "../achievements/achievements.h"
#include <string.h>
#include <stdio.h>

int csh_dotitle(void *source, int cargc, char **cargv) {
  nick *sender=source;
  unsigned int i;
  struct achievement_record *arp;
  
  if ((time(NULL) < ACHIEVEMENTS_START) || (time(NULL) > ACHIEVEMENTS_END)) {
    return CMD_ERROR;
  }
  
  arp=getachievementrec(sender->auth);
  
  if (cargc==0) {
    /* List titles */
    if (arp->count32[7] <= 1) {
      chanservstdmessage(sender, QM_NOTITLES);
      return CMD_OK;
    } 
    
    chanservstdmessage(sender, QM_TITLEHEADER);
    
    for(i=0;i<32;i++) {
      if (arp->count32[7] & (1<<i)) {
        chanservsendmessage(sender, "%c %2d %s", arp->count16[2]==i?'*':' ', i, titlenames[i]);
      }
    }
    
    chanservstdmessage(sender, QM_ENDOFLIST);
    
    return CMD_OK;
  }
  
  i=strtoul(cargv[0],NULL,10);
  
  if (i>31) {
    chanservstdmessage(sender, QM_INVALIDTITLE);
    return CMD_ERROR;
  }
  
  if (!(arp->count32[7] & (1<<i))) {
    chanservstdmessage(sender, QM_INVALIDTITLE);
    return CMD_ERROR;
  }
  
  if (arp->count16[2] == i) {
    chanservstdmessage(sender, QM_DONE);
    return CMD_OK;
  }
  
  if ((arp->count32[11] + 300) > time(NULL)) {
    chanservstdmessage(sender, QM_TITLETOOFAST);
    return CMD_ERROR;
  }
  
  arp->count32[11]=time(NULL);
  
  arp->count16[2]=i;
  setusertitle(sender->auth, i);
  
  chanservstdmessage(sender, QM_DONE);
  
  return CMD_OK;
}
